<%--
 * Component: dotcom
 *
 * Description:
 *    Correction page for studies reside on multiple HUB servers
 *
 *  @param cStudy     Study Instance UID of the study to be corrected
 * [@param cBack      Back url]
 * [@param cSession   Session id for caching study information collected from the HUB servers]
 * [@param cBreak     Breaking lock if study is locked on one of the HUBs]
 *
 * Last Updated     : $Author$
 * Update Date Time : $Date$
 * RCS File Name    : $RCSfile$
 * RCS Revision     : $Revision$
 * Locked by        : $Locker$
 * Symbolic name    : $Name$
 * State            : $State$
 *
--%><%@
	page import="java.io.*, java.util.*, imagemed.tables.*, imagemed.imtables.*, imagemed.imsession.*, imagemed.types.string.IMTypePN,
		imagemed.util.*, imagemed.jsputil.*, imagemed.exception.*, imagemed.dotcom.multihub.*, java.text.Format"

%><%@
	page errorPage="../main/exceptionHandler.jsp"

%><%!

	/** Fields to be displayed in the header table */
	static String[] m_styFields = new String[] { "PANM", "ACCN", "MODA", "PAID", "SYDT", "DSCR" };

	/** Tab page (display page under this tab) */
	static String m_tabPage = "cases/index.jsp";

	/** Fields to be excluded from the 'dynamic diff' table */
	static String[] m_excludeFields	= new String[] { "NIMG", "STAT", "RPST", "MSPI" };

	/**
	 * Sorts fields by their GUI name.
	 *
	 * @param fm     Field manager to be used for sorting the fields
	 * @param fields fields to be sorted.
	 *
	 * @return fields sorted by their GUI name (fields in m_excludeFields are excluded)
	 */
	static String[] getSortedFields( Collection<String> fields ) {
		Set<String> f2 = new TreeSet<String>( fields );
		for ( int i = 0; i < m_excludeFields.length; i++ ) {
			f2.remove( m_excludeFields[ i ] );
		}

		return IMBaseFieldManager.sortFieldsByUiName( f2 );
	}

%>
<%@page import="imagemed.types.flag.IMTypeur"%><HTML>
<HEAD>
<TITLE><%= LocalizedMessage.getSimpleMessage( "DOTCOM_PARSESTUDYDATA_HTMLPAGETITLE" ) %></title>
<%
	IMSession is = new IMSession( request, response, out );
	if ( !is.regOK() ) {
		return;
	}

	String parStudy = request.getParameter( "cStudy" );
	String parSession = request.getParameter( "cSession" );
	String parBack = request.getParameter( "cBack" );
	if ( null == parBack )
		parBack = request.getHeader( "Referer" );
	if ( null == parBack )
		parBack = "javascript:self.history.back();";

	// Checking user rights
	if ( is.regRights == null || ( is.regRights.indexOf( "@" ) == -1 && is.regRights.indexOf( "A" ) == -1 ) ) {
		throw new IMGeneralException( LocalizedMessage.getSimpleMessage( "NO_RIGHTS_REQ_PAGE" ), m_tabPage, LocalizedMessage.getSimpleMessage( "GENERAL_ERROR_TITLE" ), parBack );
	}

	if ( parStudy == null ) {
		throw new IMGeneralException( LocalizedMessage.getSimpleMessage( "DOTCOM_PARSESTUDYDATA_MISSING_PAR_CSTUDY" ), m_tabPage, LocalizedMessage.getSimpleMessage( "GENERAL_ERROR_TITLE" ), parBack );
	}

	if ( parSession == null ) {
		parSession = "" + System.currentTimeMillis() + "." + Helper.getCounter();
	}

	TabToolbox.writeIMpopup( out );
%>

<SCRIPT language="JavaScript">

	var needUnlock = 1; // in default unlock study when leaving page
	var selectedHub = 0; // Column of selected HUB
	var applyDisabled = 1;
	var highestReportNdx = 0;
	var numHubs = 0;
	var missingArray;
	var hubNames;
	var hasReports;

	function unlockStudy() {
		if (needUnlock) {
			jsPopup('unlockMultiple.jsp?cStudy=<%=parStudy%>&cSession=<%=parSession%>', 'unlockwindow',false);
		}
	}	

	function PopReport_(url_, window_) {
		w = window.open(url_, window_, 'menubar=no,location=no,resizable=yes,scrollbars=yes,status=no,width=600,height=700');
	}


	function PopImages_(url_, window_) {
		w = window.open(url_, window_, 'menubar=no,location=no,resizable=yes,scrollbars=yes,status=no,width=500,height=300');
	}

	// submitting the break lock and correction forms
	// in both cases we would keep the existing locks
	function formSubmit(frm) {
		needUnlock = 0;
		frm.submit();
	}


	function my_getelementbyid(id) {
		if (document.getElementById)
			return document.getElementById(id);
		else if (document.all)
			return document.all[id];
		else if (document.layers)
			return document.layers[id];
		else
			alert( '<%= LocalizedMessage.getSimpleMessage( "GENERAL_BROWSER_NOT_COMPATIBLE" ) %>' ); //TODO
	}

	function changeBgColor(node, color) {
		var element = my_getelementbyid(node);
		element.style.background = color;
	}

	function changeFontColor(node, color) {
		var element = my_getelementbyid(node);
		element.style.color = color;
	}

	function writeTD(node, text) {
		var element = my_getelementbyid(node);
		element.innerHTML = text;
	}

	function enableApply() {
		if (!applyDisabled)
			return;

		var content = "<A href=\"javascript:formSubmit(self.document.correctionForm);\" onMouseOver=\"window.status='Save'; return true;\">" + getButtonTag('Apply','') + "</A>";
		writeTD('spanapply', content);
		applyDisabled = 0;

	}

	function writeMissingRow() {
		for (i = 0; i < numHubs; i++) {
			var chkbox = my_getelementbyid('keep_' + i);

			if (i == selectedHub) {
				writeTD('divxinner_' + i, '0');
				changeFontColor('divxouter_' + i, 'gray');
				// chkbox.checked = false;
				chkbox.disabled = true;
			}
			else {
				writeTD('divxinner_' + i, missingArray[selectedHub][i]);
				changeFontColor('divxouter_' + i, '<%=Defs.colBodyText%>');
				chkbox.disabled = false;
			}
		}
	}

	function setCheckBox(node, ischecked) {
		var element = my_getelementbyid(node);
		element.checked = ischecked;
	}

	function checkReportRow() {
		for (i = 0; i < numHubs; i++) {
			if (!hasReports[i])
				continue;

			if (i == selectedHub) {
				setCheckBox('report_' + i, true);
			}
			else if (i == highestReportNdx) {
				setCheckBox('report_' + i, !hasReports[selectedHub]);
			}
			else {
				setCheckBox('report_' + i, false);
			}
		}
	}


	function selectHUB(hubNdx, isEnableApply) {
		changeBgColor('col_' + selectedHub, '<%=Defs.colPatEditData%>');
		changeBgColor('target_' + selectedHub, '<%=Defs.colPatEditData%>');
		selectedHub = hubNdx;
		changeBgColor('col_' + selectedHub, '<%=Defs.colStudySortColumn%>');
		changeBgColor('target_' + selectedHub, '<%=Defs.colStudySortColumn%>');
		writeMissingRow();
		if (isEnableApply)
			enableApply();
		checkReportRow();
			
	}

  </SCRIPT>
<%
	imagemed.tables.Table.printCommonScript(is);
	imagemed.http.tabs.TabBean.writeStyleOnly(is);
%>
</head>
<BODY onUnload='unlockStudy()'>
<%
	// Read study data from the local database
	String SQLtables[] = {"Dcstudy", "Dcobject", ""};
	IMFieldManager fm = new IMFieldManager("Dcfields", "Dctypes", SQLtables);

	TableDescriptor tdesc = new TableDescriptor();
	WorklistTableParams tparams = new WorklistTableParams( is.imRequest, is.getUser() );
	tparams.setDefaultFields(m_styFields);

	Properties filters = new Properties();
	filters.setProperty("SYUI", parStudy);
	tparams.setDefaultFilters(filters);
	//	out.println("<!-- default Filters set to SYUI="+parStudy+" in "+tparams+"-->");

	tdesc.setTableParams(tparams);
	tdesc.setFieldManager(fm);
	WorklistResult result = new WorklistResult(is, tdesc);
	result.setGlobal(true);
	if (!result.next()) {
		throw new IMGeneralException( LocalizedMessage.getSimpleMessage( "EXCEPTION_CASES_NO_SUCH_STUDY" ) , m_tabPage, LocalizedMessage.getSimpleMessage( "GENERAL_ERROR_TITLE" ), parBack);
	}

	StudyComparator sc = new StudyComparator(parSession, parStudy);

	Vector<Properties> vLock = new Vector<Properties>();
	String lockOper = "true".equals(request.getParameter("cBreak")) ? "Break" : "Lock";
	if (!sc.lock(lockOper, is._sid, false, is, vLock)) {
		TabToolbox.makeTabs(is, is.tabbean, m_tabPage, "White");

		// Lock problem
		StringBuffer msg = new StringBuffer();
		msg.append("<H2>");
		for (Iterator<Properties> iter = vLock.iterator(); iter.hasNext();) {
	Properties prpLock = iter.next();
	String device = prpLock.getProperty("DEVICE");
	String lockerName = prpLock.getProperty("IMLockOwner");
	String lockAge = prpLock.getProperty("IMLockAge");
	lockerName = (null == lockerName) ? LocalizedMessage.getSimpleMessage( "GENERIC_ANOTHER_USER" ) : IMTypePN.displayOrdinaryText(lockerName);

	msg.append("<BR>" + LocalizedMessage.getCompoundMessage( "STUDY_LOCK_LOCKED_DEVICE_BY", new Format[] { null, null, null}, new Object[] { device, lockerName, ReportToolbox.getLockAgeMessage(lockAge) }, false ) + ".<P>\n");
		}

		String locksString = vLock.size() > 1 ? LocalizedMessage.getSimpleMessage( "STUDY_BREAK_THE_LOCK_PLURAL" ) : LocalizedMessage.getSimpleMessage( "STUDY_BREAK_THE_LOCK" );

		if( is.hasRight( IMTypeur.BREAK_LOCK_RIGHT ) ) {
	msg.append( locksString + "<BR><BR></H2>");
		}

		MessageBox box = new MessageBox( LocalizedMessage.getSimpleMessage( "GENERIC_LOCKED" ), "60%");
		box.setMessage(msg.toString());
		if( is.hasRight( IMTypeur.BREAK_LOCK_RIGHT ) ) {
	box.addButton(new Button("javascript:formSubmit(self.document.breakForm);", "BUTTON_BREAK", vLock.size() > 1 ? "STUDY_BREAK_THE_LOCK_PLURAL" : "STUDY_BREAK_THE_LOCK" ));
		}
		box.addButton(new Button(parBack, "BUTTON_CANCEL", "BUTTON_CANCEL" ));
%>
<FORM METHOD="GET" NAME="breakForm"><INPUT TYPE="HIDDEN"
	NAME="cStudy" VALUE="<%= Helper.htmlEncode(parStudy) %>"> <INPUT
	TYPE="HIDDEN" NAME="cSession"
	VALUE="<%= Helper.htmlEncode(parSession) %>"> <INPUT
	TYPE="HIDDEN" NAME="cBack" VALUE="<%= Helper.htmlEncode(parBack) %>">
<INPUT TYPE="HIDDEN" NAME="cBreak" VALUE="true"></FORM>
<CENTER>
<%
	box.print(is.out);
%>
</CENTER>
</BODY>
</HTML>
<%
	return;
	}


	sc.collectStudyData(is, false);

	String devices[] = sc.getDevices( is );
	String[] fields = getSortedFields( sc.getConflictFields() );

	TabToolbox.makeTabs(is, is.tabbean, m_tabPage, "White");
%>
<TABLE border=1 cellpadding=0 cellspacing=0 width="100%">
	<FORM method="post" name="correctionForm" action="correct.jsp">
	<TR>
		<TD class=BgShadow width="100%">
		<TABLE border=0 cellpadding=0 cellspacing=0 width="100%">
			<TR>
				<TD width="50%"><BR>
				<font size=4>&nbsp;&nbsp;<%= LocalizedMessage.getSimpleMessage( "DOTCOM_PARSESTUDYDATA_CORRECT_STUDY_RESIDES" ) %></font><BR>
				<BR>
				</TD>
				<TD width="50%" align=right>&nbsp;</TD>
			</TR>
		</TABLE>
		</TD>
	</TR>
</TABLE>


<TABLE border=1 cellpadding=0 cellspacing=0 width=100% class=BgShadow>
	<TR>
		<TD class=BgMedDark><FONT size="2"><%=fm.getHeaderName("PANM")%></FONT></TD>
		<TD nowrap><%=fm.displayText(result.getValue("PANM"), "PANM", result, null)%></TD>
		<TD class=BgMedDark><FONT size="2"><%=fm.getHeaderName("ACCN")%></FONT></TD>
		<TD nowrap><%=fm.displayText(result.getValue("ACCN"), "ACCN", result, null)%></TD>
		<TD class=BgMedDark><FONT size="2"><%=fm.getHeaderName("MODA")%></FONT></TD>
		<TD nowrap><%=fm.displayText(result.getValue("MODA"), "MODA", result, null)%></TD>
	</TR>
	<TR>
		<TD class=BgMedDark><FONT size="2"><%=fm.getHeaderName("PAID")%></FONT></TD>
		<TD nowrap><%=fm.displayText(result.getValue("PAID"), "PAID", result, null)%></TD>
		<TD class=BgMedDark><FONT size="2"><%=fm.getHeaderName("SYDT")%></FONT></TD>
		<TD nowrap><%=fm.displayText(result.getValue("SYDT"), "SYDT", result, null)%></TD>
		<TD class=BgMedDark><FONT size="2"><%=fm.getHeaderName("DSCR")%></FONT></TD>
		<TD nowrap><%=fm.displayText(result.getValue("DSCR"), "DSCR", result, null)%></TD>
	</TR>
	<TR>
		<TD colspan="6"><BR>
		</TD>
	</TR>
</TABLE>

<SCRIPT language="JavaScript">
	numHubs = <%= devices.length %>;
	missingArray = new Array(numHubs);
	hubNames = new Array(numHubs);
	hasReports = new Array(numHubs);

	for (i = 0; i < numHubs; i++) {
		missingArray[i] = new Array(numHubs);
		for (j = 0; j < numHubs; j++) {
			missingArray[i][j] = 0;
		}
	}
<%
	int highestReportIndex = 0;
	int highestReport = 0;
	for (int i = 0; i < devices.length; i++) {
		int cumulatedStatus = sc.getCumulatedStatus(devices[i]);
		if (highestReport < cumulatedStatus) {
			highestReportIndex = i;
			highestReport = cumulatedStatus;
		}
%>	hubNames[<%=i%>] = '<%=devices[i]%>';
	hasReports[<%=i%>] = <%=sc.getNumberOfInterpretations(devices[i]) > 0%>;
<%
		Map<String, Set<ObjectData>> missingObjects = sc.getImagesMissing(devices[i]);
		for (int j = 0; j < devices.length; j++) {
			Set<ObjectData> imgs = missingObjects.get(devices[j]);
			int missingNum = (imgs == null) ? 0 : imgs.size();
%>	missingArray[<%=i%>][<%=j%>] = <%= missingNum %>;
<%
		}
	}
%>	highestReportNdx = <%=highestReportIndex%>;
 </SCRIPT>

<TABLE border=1 cellpadding=0 cellspacing=0 width=100%>
	<TR class=BgShadow>
		<TD>
		<TABLE border=0 width=100%>
			<TR>
				<TD width="20%"><BR>
				<%= LocalizedMessage.getSimpleMessage( "DOTCOM_PARSESTUDYDATA_TARGET_SERVER" ) %><BR>
				<BR>
				</TD>
				<%
					int colWidth0 = 60 / devices.length;
					for (int i = 0; i < devices.length; i++) {
				%><TD width="<%=colWidth0%>%" id="target_<%=i%>"><INPUT
					TYPE="RADIO" NAME="cTarget"
					VALUE="<%= Helper.htmlEncode(devices[i]) %>"
					onClick="if (this.checked) {selectHUB(<%=i%>, true);}"> <%=devices[i]%></TD>
				<%
					}
				%>
				<TD align="right"><A HREF="javascript:formSubmit(self.document.correctionForm);"><%= JSHelper.getJsLocalizedButton( "BUTTON_APPLY", "BUTTON_NULL", false ) %></A>&nbsp;&nbsp;&nbsp;&nbsp;<A
					href="<%=parBack%>"
					onMouseOver="window.status='Cancel'; return true;"><%= JSHelper.getJsLocalizedButton( "BUTTON_CANCEL", "BUTTON_NULL", false ) %></A>&nbsp;&nbsp;&nbsp;&nbsp;</TD>
			</TR>
		</TABLE>
		</TD>
	<TR>
</TABLE>


<TABLE border=1 cellpadding=0 cellspacing=0 width=100%>
	<%
		// For selecting the recommended device
		int highestScoreNdx = 0;
		int highestScore = 0;
		int numNonZero = 0; // number of hubs having a score larger than 0

		StringBuffer headers = new StringBuffer();
		StringBuffer cols = new StringBuffer();
		headers.append( LocalizedMessage.getSimpleMessage( "GENERIC_FIELD" ) );
		cols.append("<COL style=\"background: " + Defs.colPatEditRow + "\">");
		int colwidth = 80 / devices.length;
		for (int i = 0; i < devices.length; i++) {
			int score = sc.getScores(devices[i]);
			if (score > 0) {
				numNonZero++;
				if (highestScore < score) {
					highestScore = score;
					highestScoreNdx = i;
				}
			}
			headers.append(", ").append(devices[i]); // .append(" [" + score + "]");
			cols.append("<COL width=\"" + colwidth + "%\" id=\"col_" + i + "\" style=\"background: " + Defs.colPatEditData + "\">");
		}

		out.println(cols.toString());
		out.write(Helper.header3D(headers.toString()));
	%>
	<TR>
		<TD><%= LocalizedMessage.getSimpleMessage( "DOTCOM_PARSESTUDYDATA_NUMBER_IMAGES" ) %></TD>
		<%
			for (int i = 0; i < devices.length; i++) {
				String link = "showImages.jsp?cStudy=" + parStudy + "&cSession=" + parSession + "&cDevice=" + devices[i];
				String numImgs = fm.displayText(sc.getFieldValue(devices[i], "NIMG"), "NIMG");
		%><TD><a
			href="javascript:PopImages_('<%=link%>', 'images_<%=devices[i]%>');"
			onMouseOver="window.status='view images reside on <%=devices[i]%>'; return true;"><%=numImgs%></A></TD>
		<%
			}
		%>
	</TR>
	<TR>
		<TD><%= LocalizedMessage.getSimpleMessage( "DOTCOM_PARSESTUDYDATA_STUDY_STATUS" ) %></TD>
		<%
			for (int i = 0; i < devices.length; i++) {
				String stat = fm.displayText(sc.getFieldValue(devices[i], "STAT"), "STAT");
		%><TD><%=stat%></TD>
		<%
			}
		%><%--
</TR><TR><TD>Number of objects</TD>
<%
	for (int i = 0; i < devices.length; i++) {
		String numObjs = fm.displayText(sc.getFieldValue(devices[i], "NOBJ"), "NOBJ");
		%><TD><%= numObjs %></TD><%
	}
%>--%>
	</TR>
	<TR>
		<TD><%= LocalizedMessage.getSimpleMessage( "DOTCOM_PARSESTUDYDATA_NUMBER_MISSING_OBJ" ) %>&nbsp;&nbsp;</TD>
		<%
			for (int i = 0; i < devices.length; i++) {
		%><TD><SPAN id="divxouter_<%= i %>"><SPAN
			id="divxinner_<%=i%>">&nbsp;</SPAN> <input id="keep_<%=i%>"
			type="checkbox" name="cKeepImages" value="<%=devices[i]%>" checked>
		<%= LocalizedMessage.getSimpleMessage( "DOTCOM_PARSESUTYDDATA_KEEP_MISSING_OBJ" ) %></SPAN></TD>
		<%
			}
		%>
	</TR>
	<TR>
		<TD><%= LocalizedMessage.getSimpleMessage( "GENERIC_REPORT" )%></TD>
		<%
			String parentSession = "&ParentSession=" + is._sid + "&RefererHost=" + RedirectToolbox.getThisHostEnc(is);
			for (int i = 0; i < devices.length; i++) {
				int numInterpretations = sc.getNumberOfInterpretations(devices[i]);
				if (numInterpretations < 1) {
		%><TD><span class=FontDisabled><%= LocalizedMessage.getSimpleMessage( "GENERIC_NONE" ).toUpperCase() %></span></TD>
		<%
			continue;
				}
				numInterpretations--; // number of addenda
				String link = RedirectToolbox.getURL(devices[i], is.regIP, null) + "/cases/reportview.jsp?cGr=" + parStudy + "&cPrintFriendly=true&cDontPrint=true" + parentSession;
				String reportStatus = fm.displayText(sc.getFieldValue(devices[i], "RPST"), "RPST");
				if (numInterpretations > 0) {
					reportStatus = reportStatus + " + " + numInterpretations + (numInterpretations > 1 ? LocalizedMessage.getSimpleMessage( "GENERIC_ADDENDA" ) : LocalizedMessage.getSimpleMessage( "GENERIC_ADDENDUM" ) );
				}
		%><TD><a
			href="javascript:PopReport_('<%=link%>', 'rep<%=devices[i]%>');"
			onMouseOver="window.status='view report'; return true;"><%=reportStatus%></A>
		<INPUT ID="report_<%=i%>" TYPE="CHECKBOX" NAME="cKeepReport"
			VALUE="<%=Helper.htmlEncode(devices[i])%>"> <%= LocalizedMessage.getSimpleMessage( "DOTCOM_PARSESTUDYDATA_KEEP_REPORTS" ) %></TD>
		<%
			}
		%>
	</TR>
	<TR>
		<TD class=FieldBlock colspan="<%=devices.length + 1%>"></TD>
	</TR>
	<%
		for (String fld: fields) {
	%>
	<TR>
		<TD><%=fm.getHeaderName(fld)%></TD>
		<%
			for (int i = 0; i < devices.length; i++) {
		%><TD nowrap><%=fm.displayText(sc.getFieldValue(devices[i], fld), fld)%></TD>
		<%
			}
		%>
	</TR>
	<%
		}
	%>
	<TR>
		<TD class=FieldBlock colspan="<%=devices.length + 1%>"></td>
	</TR>
</TABLE>

<script language="javascript">
	selectHUB(<%= highestScoreNdx %>, false);
</script>

<INPUT TYPE="HIDDEN" NAME="cNumDevs" VALUE="<%= devices.length %>">
<INPUT TYPE="HIDDEN" NAME="cStudy" VALUE="<%= Helper.htmlEncode(parStudy) %>">
<INPUT TYPE="HIDDEN" NAME="cSession" VALUE="<%= Helper.htmlEncode(parSession) %>">
<INPUT TYPE="HIDDEN" NAME="cBack" VALUE="<%= Helper.htmlEncode(parBack) %>">
</FORM>

</BODY>
</HTML>
