<%--
 * Component: dotcom
 *
 * Description:
 *    Start study synchronization toward the CWL parent server.
 *    The page is intended to be called by the CWL parent only for a study is being re-synchronized.
 *
 * Parameters:
 *
 *    cStudy      - Study Instance UID of the study to be re-synchronized
 *
 *
 * Last Updated     : $Author$
 * Update Date Time : $Date$
 * RCS File Name    : $RCSfile$
 * RCS Revision     : $Revision$
 * Locked by        : $Locker$
 * Symbolic name    : $Name$
 * State            : $State$
 *
--%><%@
	page import="imagemed.imsession.*, imagemed.dotcom.*, imagemed.jsputil.*, imagemed.util.*, imagemed.taskd.IMScriptContext"

%><%@
	page errorPage="../main/exceptionHandler.jsp"

%><%!
	static Syslog logger = new Syslog("sync2parent.jsp", 0, IMEnvBase.getEnv("LOG_FACILITY"));

%><%

	IMSession is = new IMSession(request, response, out);

	IMScriptContext context = IMScriptContext.readJobContextFrom( request );

	try {
		DotcomToolbox.checkClient(is, "P", false);

		if (!DotcomConfig.isParentDbOnly()) {
			logger.syslog(Syslog.LOG_ERR, "Parent is not s CWL server");
			// Parent is not a CWL server
			return;
		}
	
		String parStudy = request.getParameter("cStudy");
		if (parStudy == null) {
			logger.syslog(Syslog.LOG_ERR, "Missing parameter: cStudy");
			// Missing parameter
			return;
		}

		StudySynchronizer.startTask( context, parStudy, true ); // force synchronization
	}
	catch (Throwable th) {
		logger.syslog(Syslog.LOG_ERR, "Peer is not a parent device or an error occured (" + Helper.throwable2String(th) + ")");
		// Peer is not a parent device or an error occured
		return;
	}

	is.out.println("OK");
%>

